/*
 * JPA DAO Template
 *
 *
 * Takatuka - Template fuer JPA DAO
 *
 */

package de.ivu.elect.business.personenpruefung.boundary;

import javax.persistence.NoResultException;
import javax.persistence.NonUniqueResultException;
import javax.persistence.EntityNotFoundException;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import de.ivu.elect.business.personenpruefung.entity.PersonenKonflikt;
import de.ivu.elect.business.personenpruefung.entity.PersonenKonfliktUK;

public abstract class AbstractPersonenKonfliktDAO extends de.ivu.elect.jee.entity.AbstractDAO<PersonenKonflikt,
        de.ivu.elect.business.personenpruefung.entity.PersonenKonfliktPK
    , PersonenKonfliktUK> {

  private static final long serialVersionUID = 1L;

  private static final Logger LOG = LoggerFactory.getLogger(AbstractPersonenKonfliktDAO.class);

  public AbstractPersonenKonfliktDAO() {
    super();
  }

  public boolean isEntityWithPKPresent(
            de.ivu.elect.business.personenpruefung.entity.PersonenKonfliktPK
     pk) {
    if (pk != null && pk.getId() != null) {
      return findByPrimaryKey(pk) != null;
    }

    return false;
  }

  @Override
  public PersonenKonflikt findByPrimaryKey(
        de.ivu.elect.business.personenpruefung.entity.PersonenKonfliktPK
      pk) {
    if (pk != null && pk.getId() != null) {
      return findByPrimaryKey(pk.getId());
    }

    throw new IllegalArgumentException("PK oder PK.getId() ist null! [pk = " + pk + "]");
  }


  @Override
  protected PersonenKonflikt findByPrimaryKey(Long id) {
    if (id == null) {
      throw new IllegalArgumentException("ID ist null! [id = " + id + "]");
    }
  return getEntityManager().find(PersonenKonflikt.class, id, CACHE_PROPERTIES);
  }



     /**
      * Name: KonfliktArtAndKonfliktStatusNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT obj FROM PersonenKonflikt obj WHERE obj.personenKonfliktArt IN (?1) AND obj.personenKonfliktStatus IN (?2)<br>
      * SQL: <br>
      */
     public java.util.List<PersonenKonflikt> findByKonfliktArtAndKonfliktStatus( @javax.annotation.Nonnull java.util.Collection<de.ivu.elect.business.personenpruefung.entity.PersonenKonfliktArt> konfliktArten,  @javax.annotation.Nonnull java.util.Collection<de.ivu.elect.business.personenpruefung.entity.PersonenKonfliktStatus> konfliktStatus) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

            try {

          		  			  java.util.Collection<de.ivu.elect.business.personenpruefung.entity.PersonenKonfliktArt> konfliktArtenCheckedAndAttached =  konfliktArten ;
		  			  java.util.Collection<de.ivu.elect.business.personenpruefung.entity.PersonenKonfliktStatus> konfliktStatusCheckedAndAttached =  konfliktStatus ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("PERSONEN_KONFLIKT.KonfliktArtAndKonfliktStatus")
                              .setParameter(1, konfliktArtenCheckedAndAttached)
                                        .setParameter(2, konfliktStatusCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (NonUniqueResultException nure) {
    LOG.warn("PersonenKonflikt, findByKonfliktArtAndKonfliktStatus - NonUniqueResultException, Parameter: "
           + ", konfliktArten:'"+konfliktArten+"'"
           + ", konfliktStatus:'"+konfliktStatus+"'"
    
        );
    throw nure;
        }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByKonfliktArtAndKonfliktStatus(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: PersonAndKonfliktArtNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT k FROM PersonenKonflikt k WHERE k.personendaten = ?1 AND k.personenKonfliktArt IN (?2)<br>
      * SQL: <br>
      */
     public java.util.List<PersonenKonflikt> findByPersonAndKonfliktArt( @javax.annotation.Nonnull de.ivu.elect.business.person.entity.Personendaten personendaten,  @javax.annotation.Nonnull java.util.Collection<de.ivu.elect.business.personenpruefung.entity.PersonenKonfliktArt> konfliktArten) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.person.entity.Personendaten personendatenCheckedAndAttached =  checkAndAttach(personendaten, de.ivu.elect.business.person.entity.Personendaten.class, "personendaten"); ;
		  			  java.util.Collection<de.ivu.elect.business.personenpruefung.entity.PersonenKonfliktArt> konfliktArtenCheckedAndAttached =  konfliktArten ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("PERSONEN_KONFLIKT.PersonAndKonfliktArt")
                              .setParameter(1, personendatenCheckedAndAttached)
                                        .setParameter(2, konfliktArtenCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByPersonAndKonfliktArt - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("PersonenKonflikt, findByPersonAndKonfliktArt - NonUniqueResultException, Parameter: "
           + ", personendaten:'"+personendaten+"'"
           + ", konfliktArten:'"+konfliktArten+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByPersonAndKonfliktArt(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: PersonAndKonfliktStatusNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT k FROM PersonenKonflikt k WHERE k.personendaten = ?1 AND k.personenKonfliktStatus IN (?2)<br>
      * SQL: <br>
      */
     public java.util.List<PersonenKonflikt> findByPersonAndKonfliktStatus( @javax.annotation.Nonnull de.ivu.elect.business.person.entity.Personendaten personendaten,  @javax.annotation.Nonnull java.util.Collection<de.ivu.elect.business.personenpruefung.entity.PersonenKonfliktStatus> konfliktStatus) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.person.entity.Personendaten personendatenCheckedAndAttached =  checkAndAttach(personendaten, de.ivu.elect.business.person.entity.Personendaten.class, "personendaten"); ;
		  			  java.util.Collection<de.ivu.elect.business.personenpruefung.entity.PersonenKonfliktStatus> konfliktStatusCheckedAndAttached =  konfliktStatus ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("PERSONEN_KONFLIKT.PersonAndKonfliktStatus")
                              .setParameter(1, personendatenCheckedAndAttached)
                                        .setParameter(2, konfliktStatusCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByPersonAndKonfliktStatus - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("PersonenKonflikt, findByPersonAndKonfliktStatus - NonUniqueResultException, Parameter: "
           + ", personendaten:'"+personendaten+"'"
           + ", konfliktStatus:'"+konfliktStatus+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByPersonAndKonfliktStatus(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: WahlAndKonfliktArtAndKonfliktStatusNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT obj FROM PersonenKonflikt obj WHERE obj.personendaten.wahl = ?1 AND obj.personenKonfliktArt IN (?2) AND obj.personenKonfliktStatus IN (?3)<br>
      * SQL: <br>
      */
     public java.util.List<PersonenKonflikt> findByWahlAndKonfliktArtAndKonfliktStatus( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl,  @javax.annotation.Nonnull java.util.Collection<de.ivu.elect.business.personenpruefung.entity.PersonenKonfliktArt> konfliktArten,  @javax.annotation.Nonnull java.util.Collection<de.ivu.elect.business.personenpruefung.entity.PersonenKonfliktStatus> konfliktStatus) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

            try {

          		  			  de.ivu.elect.business.wahl.entity.Wahl wahlCheckedAndAttached =  checkAndAttach(wahl, de.ivu.elect.business.wahl.entity.Wahl.class, "wahl"); ;
		  			  java.util.Collection<de.ivu.elect.business.personenpruefung.entity.PersonenKonfliktArt> konfliktArtenCheckedAndAttached =  konfliktArten ;
		  			  java.util.Collection<de.ivu.elect.business.personenpruefung.entity.PersonenKonfliktStatus> konfliktStatusCheckedAndAttached =  konfliktStatus ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("PERSONEN_KONFLIKT.WahlAndKonfliktArtAndKonfliktStatus")
                              .setParameter(1, wahlCheckedAndAttached)
                                        .setParameter(2, konfliktArtenCheckedAndAttached)
                                        .setParameter(3, konfliktStatusCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (NonUniqueResultException nure) {
    LOG.warn("PersonenKonflikt, findByWahlAndKonfliktArtAndKonfliktStatus - NonUniqueResultException, Parameter: "
           + ", wahl:'"+wahl+"'"
           + ", konfliktArten:'"+konfliktArten+"'"
           + ", konfliktStatus:'"+konfliktStatus+"'"
    
        );
    throw nure;
        }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahlAndKonfliktArtAndKonfliktStatus(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: WahlterminAndKonfliktArtAndKontoverbindungIbanNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT w FROM PersonenKonflikt w JOIN FETCH w.personendaten p JOIN FETCH p.kontoverbindung kv WHERE w.personenKonfliktArt =?2 AND p.wahltermin = ?1 AND kv.iban = ?3<br>
      * SQL: <br>
      */
     public java.util.List<PersonenKonflikt> findByWahlterminAndKonfliktArtAndKontoverbindungIban( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahltermin wahltermin,  @javax.annotation.Nonnull de.ivu.elect.business.personenpruefung.entity.PersonenKonfliktArt konfliktArt,  @javax.annotation.Nonnull java.lang.String iban) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

            try {

          		  			  de.ivu.elect.business.wahl.entity.Wahltermin wahlterminCheckedAndAttached =  checkAndAttach(wahltermin, de.ivu.elect.business.wahl.entity.Wahltermin.class, "wahltermin"); ;
		  			  de.ivu.elect.business.personenpruefung.entity.PersonenKonfliktArt konfliktArtCheckedAndAttached =  checkAndAttach(konfliktArt, de.ivu.elect.business.personenpruefung.entity.PersonenKonfliktArt.class, "konfliktArt"); ;
		  			  java.lang.String ibanCheckedAndAttached =  iban ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("PERSONEN_KONFLIKT.WahlterminAndKonfliktArtAndKontoverbindungIban")
                              .setParameter(1, wahlterminCheckedAndAttached)
                                        .setParameter(2, konfliktArtCheckedAndAttached)
                                        .setParameter(3, ibanCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (NonUniqueResultException nure) {
    LOG.warn("PersonenKonflikt, findByWahlterminAndKonfliktArtAndKontoverbindungIban - NonUniqueResultException, Parameter: "
           + ", wahltermin:'"+wahltermin+"'"
           + ", konfliktArt:'"+konfliktArt+"'"
           + ", iban:'"+iban+"'"
    
        );
    throw nure;
        }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahlterminAndKonfliktArtAndKontoverbindungIban(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: WahlterminAndKonfliktArtNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT w FROM PersonenKonflikt w WHERE w.personendaten.wahltermin = ?1 AND w.personenKonfliktArt =?2<br>
      * SQL: <br>
      */
     public java.util.List<PersonenKonflikt> findByWahlterminAndKonfliktArt( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahltermin wahltermin,  @javax.annotation.Nonnull de.ivu.elect.business.personenpruefung.entity.PersonenKonfliktArt konfliktArt) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

            try {

          		  			  de.ivu.elect.business.wahl.entity.Wahltermin wahlterminCheckedAndAttached =  checkAndAttach(wahltermin, de.ivu.elect.business.wahl.entity.Wahltermin.class, "wahltermin"); ;
		  			  de.ivu.elect.business.personenpruefung.entity.PersonenKonfliktArt konfliktArtCheckedAndAttached =  checkAndAttach(konfliktArt, de.ivu.elect.business.personenpruefung.entity.PersonenKonfliktArt.class, "konfliktArt"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("PERSONEN_KONFLIKT.WahlterminAndKonfliktArt")
                              .setParameter(1, wahlterminCheckedAndAttached)
                                        .setParameter(2, konfliktArtCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (NonUniqueResultException nure) {
    LOG.warn("PersonenKonflikt, findByWahlterminAndKonfliktArt - NonUniqueResultException, Parameter: "
           + ", wahltermin:'"+wahltermin+"'"
           + ", konfliktArt:'"+konfliktArt+"'"
    
        );
    throw nure;
        }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahlterminAndKonfliktArt(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }



  @Override
  public boolean isEntityWithUKPresent(de.ivu.elect.business.personenpruefung.entity.PersonenKonfliktUK uk) {
    try {
      return findByUK(uk) != null;
    } catch (javax.persistence.NoResultException nre) {
      return false;
    }
  }

  @Override
  public boolean isEntityWithUKHasPK(de.ivu.elect.business.personenpruefung.entity.PersonenKonfliktUK uk,
        de.ivu.elect.business.personenpruefung.entity.PersonenKonfliktPK
      pk

  ) {
    try {
      return findByUK(uk).getPk().equals(pk);
    } catch (NoResultException ignored) {
      // Do nothing - be happy.
    }
    return true;
  }

    public de.ivu.elect.business.personenpruefung.entity.PersonenKonflikt findByUK(de.ivu.elect.business.personenpruefung.entity.PersonenKonfliktUK uk){
        throw new UnsupportedOperationException("Kein UK definiert");
    }


}